#!/bin/sh

# ------------------------------------------------------------------------ {COPYRIGHT-TOP}
# Licensed Materials - Property of IBM
# Restricted Materials of IBM
# IBM Tivoli Usage and Accounting Manager
# 5724-O33, 5765-UAV, 5765-UA7, 44E7863
# (c) Copyright IBM Corp. 2004, 2008 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# ------------------------------------------------------------------------ {COPYRIGHT-END}

if [ "$TUAM_HOME" != "" ]
then
   echo Stopping eWAS...
   
   if  [ "$1" != "" -a "$2" != "" ];
   then
      echo Stopping eWAS with authentication
      "$TUAM_HOME/ewas/bin/stopServer.sh" server1 -username "$1" -password "$2"   
   else   			
      echo Stopping eWAS without authentication			
      "$TUAM_HOME/ewas/bin/stopServer.sh" server1
   fi

   echo Applying fix...
   
   cp "$TUAM_HOME/lib/aucIntegrator.jar" "$TUAM_HOME/lib/aucIntegrator.patch13"
   cp ./aucIntegrator.jar "$TUAM_HOME/lib"
   
   cp "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucIntegrator.jar" "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucIntegrator.patch13"
   cp ./aucIntegrator.jar "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib"

   cp "$TUAM_HOME/lib/aucProcessEngine.jar" "$TUAM_HOME/lib/aucProcessEngine.patch13"
   cp ./aucProcessEngine.jar "$TUAM_HOME/lib"

   cp "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucProcessEngine.jar" "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucProcessEngine.patch13"
   cp ./aucProcessEngine.jar "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib"
   
   cp "$TUAM_HOME/lib/aucCommon.jar" "$TUAM_HOME/lib/aucCommon.patch13"
   cp aucCommon.jar "$TUAM_HOME/lib"

   cp "$TUAM_HOME/collectors/tdw/StandardTemplates.xml" "$TUAM_HOME/collectors/tdw/StandardTemplates.xml.patch13"
   cp Collectors/TDW/StandardTemplates.xml "$TUAM_HOME/collectors/tdw/."

   cp "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucCommon.jar" "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib/aucCommon.jar.patch13"
   cp aucCommon.jar "$TUAM_HOME/ewas/systemApps/isclite.ear/aucConsole.war/WEB-INF/lib"

   cp "$TUAM_HOME/collectors/unixlinux/ituam_uc_aix5.tar" "$TUAM_HOME/collectors/unixlinux/ituam_uc_aix5.tar.patch13"
   cp ituam_uc_aix5.tar "$TUAM_HOME/collectors/unixlinux/ituam_uc_aix5.tar"
   
   if [ -f "$TUAM_HOME/collectors/unix/scripts/aacct/ituam_format_aacct" ]
   then
     cp "$TUAM_HOME/collectors/unix/scripts/aacct/ituam_format_aacct" "$TUAM_HOME/collectors/unix/scripts/aacct/ituam_format_aacct.patch13"
   fi
   cp ituam_format_aacct "$TUAM_HOME/collectors/unix/scripts/aacct/ituam_format_aacct"
   
   echo Restarting eWAS...
   "$TUAM_HOME/ewas/bin/startServer.sh" server1
else   
   echo Your environment variable TUAM_HOME is not set. Set the TUAM_HOME variable to the install location of TUAM 7.1 and then rerun fix.
fi

