#!/bin/sh
#
################################################################ {COPYRIGHT-TOP}
# Licensed Materials - Property of IBM
# 
# "Restricted Materials of IBM"
#
# IBM Tivoli Usage and Accounting Manager
# 5724-O33, 5765-UAV, 5765-UA7, 44E7863
# (c) Copyright IBM Corp. 1996,2004, 2007
#
# US Governmant Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
################################################################ {COPYRIGHT-END}
#
#     Script: ituam_date,awk
# 
#  ituam_date.awk Modification Log
# 
#	DEL V1.1 15-Aug-1997
#
#		Initial creation of this script
#
#	DEL V1.2 27-May-1998
#
#		Added automatic detection and correct processing
#		for certain European implementations of date which
#		return 7 (vice 6 fields), e.g.,
#	 	Wed May 27 15:30:16 MET DST 1998 vice
#		Wed May 27 15:30:16 EST 1998
#
#	GCB V1.3 01-Sep-1999
#
#		Added ITUAM Lab headers.
#

BEGIN {
# Some version of nawk, notably SunOS 4.x, do not support
# tolower.  If the version of nawk does NOT support tolower,
# set the flag variable USETOLOWER = "N", otherwise leave it as
# USETOLOWER = "Y"

      USETOLOWER = "Y"
      num_month["jan"]=1
      num_month["feb"]=2
      num_month["mar"]=3
      num_month["apr"]=4
      num_month["may"]=5
      num_month["jun"]=6
      num_month["jul"]=7
      num_month["aug"]=8
      num_month["sep"]=9
      num_month["oct"]=10
      num_month["nov"]=11
      num_month["dec"]=12

      mon_num[1]="jan"
      mon_num[2]="feb"
      mon_num[3]="mar"
      mon_num[4]="apr"
      mon_num[5]="may"
      mon_num[6]="jun"
      mon_num[7]="jul"
      mon_num[8]="aug"
      mon_num[9]="sep"
      mon_num[10]="oct"
      mon_num[11]="nov"
      mon_num[12]="dec"

      num_dow["sun"]=0
      num_dow["mon"]=1
      num_dow["tue"]=2
      num_dow["wed"]=3
      num_dow["thu"]=4
      num_dow["fri"]=5
      num_dow["sat"]=6

      dow_num[0]="sun"
      dow_num[1]="mon"
      dow_num[2]="tue"
      dow_num[3]="wed"
      dow_num[4]="thu"
      dow_num[5]="fri"
      dow_num[6]="sat"

   if(USETOLOWER == "N") {
      tolow["A"]="a"
      tolow["B"]="b"
      tolow["C"]="c"
      tolow["D"]="d"
      tolow["E"]="e"
      tolow["F"]="f"
      tolow["G"]="g"
      tolow["H"]="h"
      tolow["I"]="i"
      tolow["J"]="j"
      tolow["K"]="k"
      tolow["L"]="l"
      tolow["M"]="m"
      tolow["N"]="n"
      tolow["O"]="o"
      tolow["P"]="p"
      tolow["Q"]="q"
      tolow["R"]="r"
      tolow["S"]="s"
      tolow["T"]="t"
      tolow["U"]="u"
      tolow["V"]="v"
      tolow["W"]="w"
      tolow["X"]="x"
      tolow["Y"]="y"
      tolow["Z"]="z"
      }

  } #end BEGIN 

      
  {dow = month = dom = year = action = arg = output = date =  0}
  {today_jul = today_vms = 0}


   { if(USETOLOWER == "N") {
      dow = tolo($1)
      month = tolo($2)
    }
    else {
      dow = tolower($1)
      month = tolower($2)
      }
    }
    {dom = $3}

   { if (NF > 5) {
    {if ($6 ~ /^[12][0-9][0-9][0-9]$/) {
      year = $6
        if ($7 == "last" || $7 == "this" || $7 == "convert" || $7 == "validate") {
        action = $7
        arg = $8
        output = $9
        }
    }
   else {
   if ($7  ~ /^[12][0-9][0-9][0-9]$/) {
      year = $7
      if ($8 == "last" || $8 == "this" || $8 == "convert" || $8 == "validate") {
         action = $8
          arg = $9
          output = $10
      } 
    }}}
    date = sprintf("%d-%s-%4d",dom,month,year)
    {today_vms = sprintf("%02d-%s-%4d",dom,month,year)}
    {today_jul = ituam_dat_jul(today_vms)}
    {if (today_jul == "0") {print "0";next }}       
    } 
    else {
     date = $1
     today_jul = ituam_dat_jul(date)
    {if (today_jul == "0") {print "0";next }}
     action = $2
     if(action == "last" || action == "this") {print "0";next}
     arg = $3
     if(arg == "week" || arg == "year") {print "0";next}
     output = $4
     }}  

# Validate - note that all bad input dates are eliminated above 

  {if (action == "validate") {
     print "1"
     next
     }} 

# This excludes converted dates +- 27 years from the input date 
  {if (action == "convert") {
    if(arg > 10000 || arg < (-10000)) {
       print "0";next
       }}
  }


 {begin_j = begin_j = begin = since_j = since_d = since = temp = 0}
 {curr_month = curr_year = 0}
# Consider relative actions 

   {if (action == "last" || action == "this") {
    if(arg == "week") {
       if (action == "last") {
          before_j =  today_jul - num_dow[dow]
          if (before_j < 8) {print "0";next}
          since_j = before_j - 7
          since = ituam_jul_dat(since_j,output)
          if (since == "0") {print "0";next}
          before = ituam_jul_dat(before_j,output)
          if (before == "0") {print "0";next}
          temp = sprintf("%s:%s",since,before)
          print temp
          next
         }
       if(action == "this") {
          before_j = today_jul + 1
          if (before_j < 8) {print "0";next}
          since_j = today_jul - num_dow[dow]
          since = ituam_jul_dat(since_j,output)
          if (since  == "0") {print "0";next}
          before = ituam_jul_dat(before_j,output)
          if (before  == "0") {print "0";next}
          temp = sprintf("%s:%s",since,before)
          print temp
          next
          }
       print "0"; next
       }
     if(arg == "month") {
        if(action == "this") {
           before_j = today_jul + 1                
           if (before_j < dom) {print "0";next}
           before = ituam_jul_dat(before_j,output)
           if (before  == "0") {print "0";next}
           since_j = before_j - dom
           since = ituam_jul_dat(since_j,output)
           if (since  == "0") {print "0";next}
           temp = sprintf("%s:%s",since,before)
           print temp
           next
           }
         if(action == "last")  {
            curr_month = month
            curr_year = year
            temp = num_month[month] -1
            if (temp < 1) {
               temp += 12
               year -= 1
               }
            month = mon_num[temp]
            since_d = sprintf("1-%s-%4d",month,year)
            since_j = ituam_dat_jul(since_d)
            if (since_j == "0") {print "0";next}
            since = ituam_jul_dat(since_j,output)
	         if (since == "0") {print "0";next}
            before_d = sprintf("1-%s-%4d",curr_month, curr_year)
            before_j = ituam_dat_jul(before_d)
            if (before_j  == "0") {print "0";next}
            before = ituam_jul_dat(before_j,output)
            if(before == "0") {print "0";next}
            temp = sprintf("%s:%s",since,before)            
            print temp
            next
           }
          print "0"; next 
         }

      if(arg == "year") {
           if(action == "this") {
             before_j = today_jul + 1
             if (before_j < 32) {print "0";next}
             before = ituam_jul_dat(before_j,output)
             if (before  == "0") {print "0";next}
             since_d = sprintf("1-jan-%4d",year)
             since_j = ituam_dat_jul(since_d)
             if (since_j == "0") {print "0";next}
             since = ituam_jul_dat(since_j,output)
             if(since == "0") {print "0";next}
             temp = sprintf("%s:%s",since,before)
             print temp 
	          next
             }
           if(action == "last") {
             curr_year = year
             year --
             since_d = sprintf("1-jan-%4d",year)
             before_d = sprintf("1-jan-%4d",curr_year)
             since_j = ituam_dat_jul(since_d)
             if (since_j == "0") {print "0";next} 
             before_j = ituam_dat_jul(before_d)
             if(before_j == "0") {print "0";next} 
             since = ituam_jul_dat(since_j,output)
             if(since == "0") {print "0";next}
             before = ituam_jul_dat(before_j,output)
             if(before == "0") {print "0";next}
             temp = sprintf("%s:%s",since,before)            
             print temp
	          next
             }
           print "0"; next
       }
       print "0"; next
     }
   else {
        today_j = ituam_dat_jul(date)
        if (today_j < 8) {print "0";next}
        temp_j = today_j + (arg)
        temp_d = ituam_jul_dat(temp_j,output)
        if (temp_d == "0") {print "0";next}
        if (output == 1 ) {printf("%d", temp_d );next}
        printf("%s",temp_d)
        next
      }
}


function ituam_dat_jul(TEMP,       YEAR,MONTH,DAY,TMONTH,TEMPEVAL,GOOD) {

  if(TEMP ~  /^[0-3]?[0-9][-][ADFJONMSadfjonms][ACEOPUaceopu][BCGLNPRTVYbcglnprtvy][-][12][09][0123789][0-9]$/) {
     split(TEMP,arr,"-")
     YEAR=arr[3]
     if(USETOLOWER == "N") {
       TMONTH = tolo(arr[2])
       }
     else {
       TMONTH=tolower(arr[2])
       }
     MONTH=num_month[TMONTH]
     DAY=arr[1]
     }
  else {
     if(TEMP ~ /^[12][0-9][0-9][0-9][01][0-9][0123][0-9]$/) {
        YEAR=substr(TEMP,1,4) +0
        MONTH=substr(TEMP,5,2) +0
        DAY=substr(TEMP,7,2) +0
        }
     else {return "0"}
   }

   TEMPEVAL=sprintf("%04d%02d%02d",YEAR,MONTH,DAY)
   if (TEMPEVAL !~  /^[12][0-9][0-9][0-9][01][0-9][0123][0-9]$/) {
        return "0"
        }

   if( YEAR > 2038 || YEAR < 1978) {
         return "0"
         } 

# These regular expressions should not be combined to make a single very long
# expression since the length can be excessive in some versions of nawk

   GOOD = "N"
   if(TEMPEVAL ~ /0[1-9][0][1-9]$|0[1-9][1][0-9]$|0[13456789][2][0-9]$/) {GOOD = "Y"}
   if(TEMPEVAL ~ /0[13578][3][01]$|0[2][2][0-8]$|0[469][3][0]$/) {GOOD = "Y"}
   if(TEMPEVAL ~ /1[012][12][0-9]$|1[012][0][1-9]$|1[02][3][01]$|1[1][3][0]$/) {GOOD = "Y"}
   if(TEMPEVAL ~ /[028][048][0][2][2][9]$|[1379][26][0][2][2][9]$/) {GOOD = "Y"}
   if(GOOD == "N") {return "0"}
 
    x1 = int(YEAR + 4800)
    x2 = int((14 - MONTH) / 12)
    x3 = int(x1 - x2)
    x4 = int((1461 * x3) / 4)

    y1 = int(MONTH -2) 
    y2 = int((14 - MONTH)/12)
    y3 = int(y2 * 12)
    y4 = int(y1 + y3)
    y5 = int (367 * y4 /12)

    z1 = int(YEAR + 4900)
    z2 = int((14 - MONTH)/12)
    z3 = int(z1 - z2)
    z4 = int(z3 / 100  )
    z5 = int(3 * z4 / 4)

    temp = DAY + x4 + y5 - z5 -32075
    return temp
}


function ituam_jul_dat(JULIAN_D,type,    jdate_tmp,yy,mm,dd,temp) {

  if(JULIAN_D == 0) {
      return "0"
      }
  jdate_tmp = JULIAN_D - 1721119
  yy = int((4 * jdate_tmp - 1 ) / 146097)
  jdate_tmp = int(4 * jdate_tmp - 1 - 146097 * yy)
  dd = int(jdate_tmp / 4)
  jdate_tmp  = int(( 4 * dd + 3 ) / 1461)
  dd = int(4 * dd + 3 - 1461   * jdate_tmp)
  dd = int((dd + 4 ) / 4)
  mm = int(( 5 * dd - 3 ) / 153)
  dd = int(5 * dd - 3 - 153 * mm)
  dd = int((dd + 5 ) / 5)
  yy = int(100 * yy + jdate_tmp)
  if (mm < 10) {
      mm +=3
      }
  else {
      mm -= 9
      ++yy
      }
  if (type == 1) {
      temp=sprintf("%04d%02d%02d",yy,mm,dd)
      }
   else {if (type == 2) {
     temp=sprintf("%02d-%s-%04d",dd,mon_num[mm],yy)
     }
   else {
     temp=sprintf("%02d-%s-%04d",dd,mon_num[mm],yy)
      }
  }
  return temp
}

# tolower is not universally implemented
# notable exception is SunOS 4.x
# This function is only executed if USETOLOWER
# is set to "N" in the BEGIN statement

function tolo(TEMP,      x,i,y,OUTPUT)  {
   OUTPUT = ""
   x = length(TEMP)
   for(i = 1; i <= x; i ++) {
      y = substr(TEMP,i,1)
      if(y in tolow) {
         OUTPUT = OUTPUT tolow[y]
         }
      else {
         OUTPUT = OUTPUT y
         }
   }
   return OUTPUT
}
